# TO DO:
# np.savetxt mit allen weiteren Variablen fuellen + bei FITS file

import numpy as np
import pyfits

NUMOBJECTS = 1000000

for j in range(2):
	# SeqNr is the identifier of an object.
	SeqNr = np.arange(1,NUMOBJECTS + 1)

	# RA is the right ascension coordinate between 0 and 360 degree.
	RA = np.random.random_sample(NUMOBJECTS,)*360.0

	# DEC is the right ascension coordinate between -90 and 90 degree.
	DEC = np.random.random_sample(NUMOBJECTS,)*180.0 - 90.0

	# Xmag is the magnitude in the corresponding filter, Xmag_err the
	# error.
	rmag = np.random.random_sample(NUMOBJECTS,)*10.0 + 15.0
	rmag_err = np.random.random_sample(NUMOBJECTS,) / 5.0 - 0.1

	umag = np.random.random_sample(NUMOBJECTS,)*10.0 + 15.0
	umag_err = np.random.random_sample(NUMOBJECTS,) / 5.0 - 0.1

	gmag = np.random.random_sample(NUMOBJECTS,)*10.0 + 15.0
	gmag_err = np.random.random_sample(NUMOBJECTS,) / 5.0 - 0.1

	imag = np.random.random_sample(NUMOBJECTS,)*10.0 + 15.0
	imag_err = np.random.random_sample(NUMOBJECTS,) / 5.0 - 0.1

	zmag = np.random.random_sample(NUMOBJECTS,)*10.0 + 15.0
	zmag_err = np.random.random_sample(NUMOBJECTS,) / 5.0 - 0.1

	# Now the color values, gmr stands for "gmag - rmag".
	rmu = rmag - umag
	rmu_err = np.sqrt(rmag_err**2 + umag_err**2)
	rmg = rmag - gmag
	rmg_err = np.sqrt(rmag_err**2 + gmag_err**2)
	rmi = rmag - imag
	rmi_err = np.sqrt(rmag_err**2 + imag_err**2)
	rmz = rmag - zmag
	rmz_err = np.sqrt(rmag_err**2 + zmag_err**2)
	umg = umag - gmag
	umg_err = np.sqrt(umag_err**2 + gmag_err**2)
	umi = umag - imag
	umi_err = np.sqrt(umag_err**2 + imag_err**2)
	umz = umag - zmag
	umz_err = np.sqrt(umag_err**2 + zmag_err**2)
	gmi = gmag - imag
	gmi_err = np.sqrt(gmag_err**2 + imag_err**2)
	gmz = gmag - zmag
	gmz_err = np.sqrt(gmag_err**2 + zmag_err**2)
	imz = imag - zmag
	imz_err = np.sqrt(imag_err**2 + zmag_err**2)

	# Z is the redshift of the object, Z_err the error.
	Z = np.random.random_sample(NUMOBJECTS,)
	Z_err = np.random.random_sample(NUMOBJECTS,) / 100.0

	# Xpos and Ypos are the coordinates of the object on the camera.
	Xpos = np.random.random_sample(NUMOBJECTS,)*32000.0 - 16000.0
	Xpos_err = np.random.random_sample(NUMOBJECTS,)
	Ypos = np.random.random_sample(NUMOBJECTS,)*32000.0 - 16000.0
	Ypos_err = np.random.random_sample(NUMOBJECTS,)

	# AIRMASS is the airmass of an object, AIRMASS=1.0 means zenith and
	# let's say it's between 1.0 and 2.0.
	AIRMASS = np.random.random_sample(NUMOBJECTS,) + 1.0

	# EXPTIME is the exposure time from the observation, assuming it's
	# identical for all observations.
	EXPTIME = np.array(NUMOBJECTS*[300.0])

	# EPOCH is the epoch of the coordinate system, assuming J2000.0
	EPOCH = np.array(NUMOBJECTS*[2000.0])

	# TYPE: TYPE=0 means star, TYPE=1 means galaxy.
	TYPE = np.array(np.random.random_sample(NUMOBJECTS,) * 2.0, dtype='int64')






	# Now save it to a simple text file.
	f = open('test_' + str(j) + '.txt', 'w')
	for i in range(len(SeqNr)):
		f.write("%d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf\n" % (SeqNr[i], RA[i], DEC[i], rmag[i], umag[i], gmag[i], imag[i], zmag[i], rmag_err[i], umag_err[i], gmag_err[i], imag_err[i], zmag_err[i], Xpos[i], Ypos[i], TYPE[i], rmu[i], rmu_err[i], rmg[i], rmg_err[i], rmi[i], rmi_err[i], rmz[i], rmz_err[i], umg[i], umg_err[i], umi[i], umi_err[i], umz[i], umz_err[i], gmi[i], gmi_err[i], gmz[i], gmz_err[i], imz[i], imz_err[i], Z[i], Z_err[i], AIRMASS[i], EXPTIME[i], EPOCH[i]))
	f.close()

	# Now save everything to a FITS file. table contains all the data.
	col_SeqNr = pyfits.Column(name='SeqNr', format='J', array=SeqNr)
	col_RA = pyfits.Column(name='RA', format='D', array=RA)
	col_DEC = pyfits.Column(name='DEC', format='D', array=DEC)
	col_rmag = pyfits.Column(name='rmag', format='D', array=rmag)
	col_umag = pyfits.Column(name='umag', format='D', array=umag)
	col_gmag = pyfits.Column(name='gmag', format='D', array=gmag)
	col_imag = pyfits.Column(name='imag', format='D', array=imag)
	col_zmag = pyfits.Column(name='zmag', format='D', array=zmag)
	col_rmag_err = pyfits.Column(name='rmag_err', format='D', array=rmag_err)
	col_umag_err = pyfits.Column(name='umag_err', format='D', array=umag_err)
	col_gmag_err = pyfits.Column(name='gmag_err', format='D', array=gmag_err)
	col_imag_err = pyfits.Column(name='imag_err', format='D', array=imag_err)
	col_zmag_err = pyfits.Column(name='zmag_err', format='D', array=zmag_err)
	col_Xpos = pyfits.Column(name='Xpos', format='D', array=Xpos)
	col_Ypos = pyfits.Column(name='Ypos', format='D', array=Ypos)
	col_TYPE = pyfits.Column(name='TYPE', format='J', array=TYPE)
	col_rmu = pyfits.Column(name='rmu', format='D', array=rmu)
	col_rmu_err = pyfits.Column(name='rmu_err', format='D', array=rmu_err)
	col_rmg = pyfits.Column(name='rmg', format='D', array=rmg)
	col_rmg_err = pyfits.Column(name='rmg_err', format='D', array=rmg_err)
	col_rmi = pyfits.Column(name='rmi', format='D', array=rmi)
	col_rmi_err = pyfits.Column(name='rmi_err', format='D', array=rmi_err)
	col_rmz = pyfits.Column(name='rmz', format='D', array=rmz)
	col_rmz_err = pyfits.Column(name='rmz_err', format='D', array=rmz_err)
	col_umg = pyfits.Column(name='umg', format='D', array=umg)
	col_umg_err = pyfits.Column(name='umg_err', format='D', array=umg_err)
	col_umi = pyfits.Column(name='umi', format='D', array=umi)
	col_umi_err = pyfits.Column(name='umi_err', format='D', array=umi_err)
	col_umz = pyfits.Column(name='umz', format='D', array=umz)
	col_umz_err = pyfits.Column(name='umz_err', format='D', array=umz_err)
	col_gmi = pyfits.Column(name='gmi', format='D', array=gmi)
	col_gmi_err = pyfits.Column(name='gmi_err', format='D', array=gmi_err)
	col_gmz = pyfits.Column(name='gmz', format='D', array=gmz)
	col_gmz_err = pyfits.Column(name='gmz_err', format='D', array=gmz_err)
	col_imz = pyfits.Column(name='imz', format='D', array=imz)
	col_imz_err = pyfits.Column(name='imz_err', format='D', array=imz_err)
	col_Z = pyfits.Column(name='Z', format='D', array=Z)
	col_Z_err = pyfits.Column(name='Z_err', format='D', array=Z_err)
	col_AIRMASS = pyfits.Column(name='AIRMASS', format='D', array=AIRMASS)
	col_EXPTIME = pyfits.Column(name='EXPTIME', format='D', array=EXPTIME)
	col_EPOCH = pyfits.Column(name='EPOCH', format='D', array=EPOCH)

	cols = pyfits.ColDefs([col_SeqNr, col_RA, col_DEC, col_rmag, col_umag, col_gmag, col_imag, col_zmag, col_rmag_err, col_umag_err, col_gmag_err, col_imag_err, col_zmag_err, col_Xpos, col_Ypos, col_TYPE, col_rmu, col_rmu_err, col_rmg, col_rmg_err, col_rmi, col_rmi_err, col_rmz, col_rmz_err, col_umg, col_umg_err, col_umi, col_umi_err, col_umz, col_umz_err, col_gmi, col_gmi_err, col_gmz, col_gmz_err, col_imz, col_imz_err, col_Z, col_Z_err, col_AIRMASS, col_EXPTIME, col_EPOCH])

	tbhdu = pyfits.new_table(cols)
	tbhdu.name = 'OBJECTS'

	tbhdu.writeto('test_' + str(j) + '.fits')
