import numpy as np
import ldac

NUMOBJECTS = 1000000

table = ldac.LDACCat('test_0.fits')
data = table['OBJECTS']
# Access directly the data.
#data = ldac.LDACCat('test.fits')['OBJECTS']

# Describing the distance in degree to the moon.
MOONDISTANCE = np.random.random_sample(NUMOBJECTS,)*360.0 - 180.0

data['MOONDISTANCE'] = MOONDISTANCE

table.saveas('test_0_moondistance.fits', clobber=True)
