import numpy as np
import ldac

# Reminder: TYPE: TYPE=0 means star, TYPE=1 means galaxy.
# We want to get only the stars.

# Opening the file.
table = ldac.LDACCat('test_0.fits')
data = table['OBJECTS']

mask = (data['TYPE']==0)
filtered_data = data.filter(mask)

table['OBJECTS'] = filtered_data

table.add_history('Filtered. Now only stars.')

table.saveas('test_0_only_stars.fits', clobber=True)
